Index: /palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- /palm/trunk/SOURCE/init_3d_model.f90	(revision 666)
+++ /palm/trunk/SOURCE/init_3d_model.f90	(revision 667)
@@ -7,5 +7,19 @@
 ! Current revisions:
 ! -----------------
-! Bugfix: type conversion of '1' to 64bit for the MAX function (ngp_3d_inner)
+! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng in loops and 
+! allocation of arrays. Calls of exchange_horiz are modified.
+! Call ws_init to initialize arrays needed for statistical evaluation and 
+! optimization when ws-scheme is used.
+!
+! 
+! Initial volume flow is now calculated by using the variable hom_sum.
+! Therefore the correction of initial volume flow for non-flat topography
+! removed (removed u_nzb_p1_for_vfc and v_nzb_p1_for_vfc) 
+!
+! Changed surface boundary conditions for u and v in case of ibc_uv_b == 0 from
+! mirror bc to dirichlet boundary conditions (u=v=0), so that k=nzb is 
+! representative for the height z0 
+!
+! Bugfix: type conversion of '1' to 64bit for the MAX function (ngp_3d_inner) 
 !
 ! Former revisions:
@@ -101,4 +115,5 @@
 !------------------------------------------------------------------------------!
 
+    USE advec_ws
     USE arrays_3d
     USE averaging
@@ -147,5 +162,5 @@
               ngp_2dh_s_inner(nzb:nzt+1,0:statistic_regions),               &
               ngp_2dh_s_inner_l(nzb:nzt+1,0:statistic_regions),             &
-              rmask(nys-1:nyn+1,nxl-1:nxr+1,0:statistic_regions),           &
+              rmask(nysg:nyng,nxlg:nxrg,0:statistic_regions),           &
               sums(nzb:nzt+1,pr_palm+max_pr_user),                          &
               sums_l(nzb:nzt+1,pr_palm+max_pr_user,0:threads_per_task-1),   &
@@ -154,49 +169,49 @@
               sums_wsts_bc_l(nzb:nzt+1,0:statistic_regions),                &
               ts_value(dots_max,0:statistic_regions) )
-    ALLOCATE( km_damp_x(nxl-1:nxr+1), km_damp_y(nys-1:nyn+1) )
-
-    ALLOCATE( rif_1(nys-1:nyn+1,nxl-1:nxr+1), shf_1(nys-1:nyn+1,nxl-1:nxr+1), &
-              ts(nys-1:nyn+1,nxl-1:nxr+1), tswst_1(nys-1:nyn+1,nxl-1:nxr+1),  &
-              us(nys-1:nyn+1,nxl-1:nxr+1), usws_1(nys-1:nyn+1,nxl-1:nxr+1),   &
-              uswst_1(nys-1:nyn+1,nxl-1:nxr+1),                               &
-              vsws_1(nys-1:nyn+1,nxl-1:nxr+1),                                &
-              vswst_1(nys-1:nyn+1,nxl-1:nxr+1), z0(nys-1:nyn+1,nxl-1:nxr+1) )
+    ALLOCATE( km_damp_x(nxlg:nxrg), km_damp_y(nysg:nyng) )
+
+    ALLOCATE( rif_1(nysg:nyng,nxlg:nxrg), shf_1(nysg:nyng,nxlg:nxrg), &
+              ts(nysg:nyng,nxlg:nxrg), tswst_1(nysg:nyng,nxlg:nxrg),  &
+              us(nysg:nyng,nxlg:nxrg), usws_1(nysg:nyng,nxlg:nxrg),   &
+              uswst_1(nysg:nyng,nxlg:nxrg),                               &
+              vsws_1(nysg:nyng,nxlg:nxrg),                                &
+              vswst_1(nysg:nyng,nxlg:nxrg), z0(nysg:nyng,nxlg:nxrg) )
 
     IF ( timestep_scheme(1:5) /= 'runge' )  THEN
 !
 !--    Leapfrog scheme needs two timelevels of diffusion quantities
-       ALLOCATE( rif_2(nys-1:nyn+1,nxl-1:nxr+1),   &
-                 shf_2(nys-1:nyn+1,nxl-1:nxr+1),   &
-                 tswst_2(nys-1:nyn+1,nxl-1:nxr+1), &
-                 usws_2(nys-1:nyn+1,nxl-1:nxr+1),  &
-                 uswst_2(nys-1:nyn+1,nxl-1:nxr+1), &
-                 vswst_2(nys-1:nyn+1,nxl-1:nxr+1), &
-                 vsws_2(nys-1:nyn+1,nxl-1:nxr+1) )
+       ALLOCATE( rif_2(nysg:nyng,nxlg:nxrg),   &
+                 shf_2(nysg:nyng,nxlg:nxrg),   &
+                 tswst_2(nysg:nyng,nxlg:nxrg), &
+                 usws_2(nysg:nyng,nxlg:nxrg),  &
+                 uswst_2(nysg:nyng,nxlg:nxrg), &
+                 vswst_2(nysg:nyng,nxlg:nxrg), &
+                 vsws_2(nysg:nyng,nxlg:nxrg) )
     ENDIF
 
     ALLOCATE( d(nzb+1:nzta,nys:nyna,nxl:nxra),         &
-              e_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),  &
-              e_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),  &
-              e_3(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),  &
-              kh_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
-              km_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
-              p(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),    &
-              pt_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
-              pt_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
-              pt_3(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
-              tend(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
-              u_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),  &
-              u_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),  &
-              u_3(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),  &
-              v_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
-              v_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
-              v_3(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
-              w_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),  &
-              w_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),  &
-              w_3(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+              e_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
+              e_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
+              e_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
+              kh_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
+              km_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
+              p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),    &
+              pt_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
+              pt_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
+              pt_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
+              tend(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
+              u_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
+              u_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
+              u_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
+              v_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
+              v_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
+              v_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
+              w_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
+              w_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
+              w_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 
     IF ( timestep_scheme(1:5) /= 'runge' )  THEN
-       ALLOCATE( kh_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
-                 km_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+       ALLOCATE( kh_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
+                 km_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
     ENDIF
 
@@ -204,25 +219,25 @@
 !
 !--    2D-humidity/scalar arrays
-       ALLOCATE ( qs(nys-1:nyn+1,nxl-1:nxr+1),     &
-                  qsws_1(nys-1:nyn+1,nxl-1:nxr+1), &
-                  qswst_1(nys-1:nyn+1,nxl-1:nxr+1) )
+       ALLOCATE ( qs(nysg:nyng,nxlg:nxrg),     &
+                  qsws_1(nysg:nyng,nxlg:nxrg), &
+                  qswst_1(nysg:nyng,nxlg:nxrg) )
 
        IF ( timestep_scheme(1:5) /= 'runge' )  THEN
-          ALLOCATE( qsws_2(nys-1:nyn+1,nxl-1:nxr+1), &
-                    qswst_2(nys-1:nyn+1,nxl-1:nxr+1) )
+          ALLOCATE( qsws_2(nysg:nyng,nxlg:nxrg), &
+                    qswst_2(nysg:nyng,nxlg:nxrg) )
        ENDIF
 !
 !--    3D-humidity/scalar arrays
-       ALLOCATE( q_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
-                 q_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
-                 q_3(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+       ALLOCATE( q_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
+                 q_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
+                 q_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 
 !
 !--    3D-arrays needed for humidity only
        IF ( humidity )  THEN
-          ALLOCATE( vpt_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+          ALLOCATE( vpt_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 
           IF ( timestep_scheme(1:5) /= 'runge' )  THEN
-             ALLOCATE( vpt_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+             ALLOCATE( vpt_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
           ENDIF
 
@@ -230,9 +245,9 @@
 !
 !--          Liquid water content
-             ALLOCATE ( ql_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+             ALLOCATE ( ql_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 !
 !--          Precipitation amount and rate (only needed if output is switched)
-             ALLOCATE( precipitation_amount(nys-1:nyn+1,nxl-1:nxr+1), &
-                       precipitation_rate(nys-1:nyn+1,nxl-1:nxr+1) )
+             ALLOCATE( precipitation_amount(nysg:nyng,nxlg:nxrg), &
+                       precipitation_rate(nysg:nyng,nxlg:nxrg) )
           ENDIF
 
@@ -241,8 +256,8 @@
 !--          Liquid water content, change in liquid water content,
 !--          real volume of particles (with weighting), volume of particles
-             ALLOCATE ( ql_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
-                        ql_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
-                        ql_v(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
-                        ql_vp(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+             ALLOCATE ( ql_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
+                        ql_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
+                        ql_v(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
+                        ql_vp(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
           ENDIF
 
@@ -252,16 +267,16 @@
 
     IF ( ocean )  THEN
-       ALLOCATE( saswsb_1(nys-1:nyn+1,nxl-1:nxr+1), &
-                 saswst_1(nys-1:nyn+1,nxl-1:nxr+1) )
-       ALLOCATE( prho_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1), &
-                 rho_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),  &
-                 sa_1(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),   &
-                 sa_2(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),   &
-                 sa_3(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+       ALLOCATE( saswsb_1(nysg:nyng,nxlg:nxrg), &
+                 saswst_1(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE( prho_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
+                 rho_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
+                 sa_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),   &
+                 sa_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),   &
+                 sa_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
        prho => prho_1
        rho  => rho_1  ! routines calc_mean_profile and diffusion_e require
                       ! density to be apointer
        IF ( humidity_remote )  THEN
-          ALLOCATE( qswst_remote(nys-1:nyn+1,nxl-1:nxr+1) )
+          ALLOCATE( qswst_remote(nysg:nyng,nxlg:nxrg))
           qswst_remote = 0.0
        ENDIF
@@ -272,5 +287,5 @@
 !-- particle velocities
     IF ( use_sgs_for_particles )  THEN
-       ALLOCATE ( diss(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+       ALLOCATE ( diss(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
     ELSE
        ALLOCATE ( diss(2,2,2) )  ! required because diss is used as a
@@ -288,18 +303,18 @@
 !-- 3D-arrays for the leaf area density and the canopy drag coefficient
     IF ( plant_canopy ) THEN
-       ALLOCATE ( lad_s(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),  &
-                  lad_u(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),  &
-                  lad_v(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),  &
-                  lad_w(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),  &
-                  cdc(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+       ALLOCATE ( lad_s(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
+                  lad_u(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
+                  lad_v(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
+                  lad_w(nzb:nzt+1,nysg:nyng,nxlg:nxrg),  &
+                  cdc(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 
        IF ( passive_scalar ) THEN
-          ALLOCATE ( sls(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),   &
-                     sec(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) ) 
+          ALLOCATE ( sls(nzb:nzt+1,nysg:nyng,nxlg:nxrg),   &
+                     sec(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ) 
        ENDIF
 
        IF ( cthf /= 0.0 ) THEN
-          ALLOCATE ( lai(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1),   &
-                     canopy_heat_flux(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+          ALLOCATE ( lai(nzb:nzt+1,nysg:nyng,nxlg:nxrg),   &
+                     canopy_heat_flux(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
        ENDIF
 
@@ -309,14 +324,6 @@
 !-- 4D-array for storing the Rif-values at vertical walls
     IF ( topography /= 'flat' )  THEN
-       ALLOCATE( rif_wall(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1,1:4) )
+       ALLOCATE( rif_wall(nzb:nzt+1,nysg:nyng,nxlg:nxrg,1:4) )
        rif_wall = 0.0
-    ENDIF
-
-!
-!-- Velocities at nzb+1 needed for volume flow control
-    IF ( conserve_volume_flow )  THEN
-       ALLOCATE( u_nzb_p1_for_vfc(nys:nyn), v_nzb_p1_for_vfc(nxl:nxr) )
-       u_nzb_p1_for_vfc = 0.0
-       v_nzb_p1_for_vfc = 0.0
     ENDIF
 
@@ -325,30 +332,30 @@
 !-- are needed for radiation boundary conditions
     IF ( outflow_l )  THEN
-       ALLOCATE( u_m_l(nzb:nzt+1,nys-1:nyn+1,1:2), &
-                 v_m_l(nzb:nzt+1,nys-1:nyn+1,0:1), &
-                 w_m_l(nzb:nzt+1,nys-1:nyn+1,0:1) )
+       ALLOCATE( u_m_l(nzb:nzt+1,nysg:nyng,1:2), &
+                 v_m_l(nzb:nzt+1,nysg:nyng,0:1), &
+                 w_m_l(nzb:nzt+1,nysg:nyng,0:1) )
     ENDIF
     IF ( outflow_r )  THEN
-       ALLOCATE( u_m_r(nzb:nzt+1,nys-1:nyn+1,nx-1:nx), &
-                 v_m_r(nzb:nzt+1,nys-1:nyn+1,nx-1:nx), &
-                 w_m_r(nzb:nzt+1,nys-1:nyn+1,nx-1:nx) )
+       ALLOCATE( u_m_r(nzb:nzt+1,nysg:nyng,nx-1:nx), &
+                 v_m_r(nzb:nzt+1,nysg:nyng,nx-1:nx), &
+                 w_m_r(nzb:nzt+1,nysg:nyng,nx-1:nx) )
     ENDIF
     IF ( outflow_l  .OR.  outflow_r )  THEN
-       ALLOCATE( c_u(nzb:nzt+1,nys-1:nyn+1), c_v(nzb:nzt+1,nys-1:nyn+1), &
-                 c_w(nzb:nzt+1,nys-1:nyn+1) )
+       ALLOCATE( c_u(nzb:nzt+1,nysg:nyng), c_v(nzb:nzt+1,nysg:nyng), &
+                 c_w(nzb:nzt+1,nysg:nyng) )
     ENDIF
     IF ( outflow_s )  THEN
-       ALLOCATE( u_m_s(nzb:nzt+1,0:1,nxl-1:nxr+1), &
-                 v_m_s(nzb:nzt+1,1:2,nxl-1:nxr+1), &
-                 w_m_s(nzb:nzt+1,0:1,nxl-1:nxr+1) )
+       ALLOCATE( u_m_s(nzb:nzt+1,0:1,nxlg:nxrg), &
+                 v_m_s(nzb:nzt+1,1:2,nxlg:nxrg), &
+                 w_m_s(nzb:nzt+1,0:1,nxlg:nxrg) )
     ENDIF
     IF ( outflow_n )  THEN
-       ALLOCATE( u_m_n(nzb:nzt+1,ny-1:ny,nxl-1:nxr+1), &
-                 v_m_n(nzb:nzt+1,ny-1:ny,nxl-1:nxr+1), &
-                 w_m_n(nzb:nzt+1,ny-1:ny,nxl-1:nxr+1) )
+       ALLOCATE( u_m_n(nzb:nzt+1,ny-1:ny,nxlg:nxrg), &
+                 v_m_n(nzb:nzt+1,ny-1:ny,nxlg:nxrg), &
+                 w_m_n(nzb:nzt+1,ny-1:ny,nxlg:nxrg) )
     ENDIF
     IF ( outflow_s  .OR.  outflow_n )  THEN
-       ALLOCATE( c_u(nzb:nzt+1,nxl-1:nxr+1), c_v(nzb:nzt+1,nxl-1:nxr+1), &
-                 c_w(nzb:nzt+1,nxl-1:nxr+1) )
+       ALLOCATE( c_u(nzb:nzt+1,nxlg:nxrg), c_v(nzb:nzt+1,nxlg:nxrg), &
+                 c_w(nzb:nzt+1,nxlg:nxrg) )
     ENDIF
 
@@ -435,6 +442,6 @@
 !
 !--       Transfer initial profiles to the arrays of the 3D model
-          DO  i = nxl-1, nxr+1
-             DO  j = nys-1, nyn+1
+          DO  i = nxlg, nxrg
+             DO  j = nysg, nyng
                 e(:,j,i)  = e1d
                 kh(:,j,i) = kh1d
@@ -447,6 +454,6 @@
 
           IF ( humidity  .OR.  passive_scalar )  THEN
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    q(:,j,i) = q_init
                 ENDDO
@@ -455,6 +462,6 @@
 
           IF ( .NOT. constant_diffusion )  THEN
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    e(:,j,i)  = e1d
                 ENDDO
@@ -505,22 +512,5 @@
                 ENDDO
              ENDDO
-             IF ( conserve_volume_flow )  THEN
-                IF ( nxr == nx )  THEN
-                   DO  j = nys, nyn
-                      DO  k = nzb + 1, nzb_u_inner(j,nx)
-                         u_nzb_p1_for_vfc(j) = u_nzb_p1_for_vfc(j) + &
-                                               u1d(k) * dzu(k)
-                      ENDDO
-                   ENDDO
-                ENDIF
-                IF ( nyn == ny )  THEN
-                   DO  i = nxl, nxr
-                      DO  k = nzb + 1, nzb_v_inner(ny,i)
-                         v_nzb_p1_for_vfc(i) = v_nzb_p1_for_vfc(i) + &
-                                               v1d(k) * dzu(k)
-                      ENDDO
-                   ENDDO
-                ENDIF
-             ENDIF
+             
 !
 !--          WARNING: The extra boundary conditions set after running the
@@ -530,16 +520,21 @@
 !--          ---------  advection scheme: keep u and v zero one layer below
 !--                     the topography.
-             IF ( ibc_uv_b == 0 )  THEN
-!
-!--             Satisfying the Dirichlet condition with an extra layer below
-!--             the surface where the u and v component change their sign.
-                DO  i = nxl-1, nxr+1
-                   DO  j = nys-1, nyn+1
-                      IF ( nzb_u_inner(j,i) == 0 ) u(0,j,i) = -u(1,j,i)
-                      IF ( nzb_v_inner(j,i) == 0 ) v(0,j,i) = -v(1,j,i)
-                   ENDDO
-                ENDDO
-
-             ELSE
+!
+!--           Following was removed, because mirror boundary condition are
+!--           replaced by dirichlet boundary conditions 
+!
+!             IF ( ibc_uv_b == 0 )  THEN
+!!
+!!--             Satisfying the Dirichlet condition with an extra layer below
+!!--             the surface where the u and v component change their sign.
+!                DO  i = nxl-1, nxr+1
+!                   DO  j = nys-1, nyn+1
+!                      IF ( nzb_u_inner(j,i) == 0 ) u(0,j,i) = -u(1,j,i)
+!                      IF ( nzb_v_inner(j,i) == 0 ) v(0,j,i) = -v(1,j,i)
+!                   ENDDO
+!                ENDDO
+!
+!             ELSE
+             IF ( ibc_uv_b == 1 )  THEN
 !
 !--             Neumann condition
@@ -560,6 +555,6 @@
 !--       Use constructed initial profiles (velocity constant with height,
 !--       temperature profile with constant gradient)
-          DO  i = nxl-1, nxr+1
-             DO  j = nys-1, nyn+1
+          DO  i = nxlg, nxrg
+             DO  j = nysg, nyng
                 pt(:,j,i) = pt_init
                 u(:,j,i)  = u_init
@@ -574,32 +569,14 @@
 !--       in the limiting formula!). The original values are stored to be later
 !--       used for volume flow control.
-          DO  i = nxl-1, nxr+1
-             DO  j = nys-1, nyn+1
+          DO  i = nxlg, nxrg
+             DO  j = nysg, nyng
                 u(nzb:nzb_u_inner(j,i)+1,j,i) = 0.0
                 v(nzb:nzb_v_inner(j,i)+1,j,i) = 0.0
              ENDDO
           ENDDO
-          IF ( conserve_volume_flow )  THEN
-             IF ( nxr == nx )  THEN
-                DO  j = nys, nyn
-                   DO  k = nzb + 1, nzb_u_inner(j,nx) + 1
-                      u_nzb_p1_for_vfc(j) = u_nzb_p1_for_vfc(j) + &
-                                            u_init(k) * dzu(k)
-                   ENDDO
-                ENDDO
-             ENDIF
-             IF ( nyn == ny )  THEN
-                DO  i = nxl, nxr
-                   DO  k = nzb + 1, nzb_v_inner(ny,i) + 1
-                      v_nzb_p1_for_vfc(i) = v_nzb_p1_for_vfc(i) + &
-                                            v_init(k) * dzu(k)
-                   ENDDO
-                ENDDO
-             ENDIF
-          ENDIF
 
           IF ( humidity  .OR.  passive_scalar )  THEN
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    q(:,j,i) = q_init
                 ENDDO
@@ -608,6 +585,6 @@
 
           IF ( ocean )  THEN
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    sa(:,j,i) = sa_init
                 ENDDO
@@ -660,4 +637,10 @@
 
        ENDIF
+!
+!--    Bottom boundary
+       IF ( ibc_uv_b == 0 .OR. ibc_uv_b == 2  )  THEN
+          u(nzb,:,:) = 0.0
+          v(nzb,:,:) = 0.0
+       ENDIF
 
 !
@@ -683,8 +666,7 @@
        hom(:,1,5,:) = SPREAD( u(:,nys,nxl), 2, statistic_regions+1 )
        hom(:,1,6,:) = SPREAD( v(:,nys,nxl), 2, statistic_regions+1 )
-       IF ( ibc_uv_b == 0 )  THEN
-          hom(nzb,1,5,:) = -hom(nzb+1,1,5,:)  ! due to satisfying the Dirichlet 
-          hom(nzb,1,6,:) = -hom(nzb+1,1,6,:)  ! condition with an extra layer 
-              ! below the surface where the u and v component change their sign
+       IF ( ibc_uv_b == 0 .OR. ibc_uv_b == 2)  THEN
+          hom(nzb,1,5,:) = 0.0   
+          hom(nzb,1,6,:) = 0.0  
        ENDIF
        hom(:,1,7,:)  = SPREAD( pt(:,nys,nxl), 2, statistic_regions+1 )
@@ -733,6 +715,6 @@
 !--             Over topography surface_heatflux is replaced by wall_heatflux(0)
                 IF ( TRIM( topography ) /= 'flat' )  THEN
-                   DO  i = nxl-1, nxr+1
-                      DO  j = nys-1, nyn+1
+                   DO  i = nxlg, nxrg
+                      DO  j = nysg, nyng
                          IF ( nzb_s_inner(j,i) /= 0 )  THEN
                             shf(j,i) = wall_heatflux(0)
@@ -755,6 +737,6 @@
                 IF ( TRIM( topography ) /= 'flat' )  THEN
                    wall_qflux = wall_humidityflux
-                   DO  i = nxl-1, nxr+1
-                      DO  j = nys-1, nyn+1
+                   DO  i = nxlg, nxrg
+                      DO  j = nysg, nyng
                          IF ( nzb_s_inner(j,i) /= 0 )  THEN
                             qsws(j,i) = wall_qflux(0)
@@ -827,59 +809,4 @@
        ENDIF
 
-!
-!--    Calculate the initial volume flow at the right and north boundary
-       IF ( conserve_volume_flow )  THEN
-
-          volume_flow_initial_l = 0.0
-          volume_flow_area_l    = 0.0
-  
-          IF ( nxr == nx )  THEN
-             DO  j = nys, nyn
-                DO  k = nzb_2d(j,nx) + 1, nzt
-                   volume_flow_initial_l(1) = volume_flow_initial_l(1) + &
-                                              u(k,j,nx) * dzu(k)
-                   volume_flow_area_l(1)    = volume_flow_area_l(1) + dzu(k)
-                ENDDO
-!
-!--             Correction if velocity at nzb+1 has been set zero further above
-                volume_flow_initial_l(1) = volume_flow_initial_l(1) + &
-                                           u_nzb_p1_for_vfc(j)
-             ENDDO
-          ENDIF
-
-          IF ( nyn == ny )  THEN
-             DO  i = nxl, nxr
-                DO  k = nzb_2d(ny,i) + 1, nzt  
-                   volume_flow_initial_l(2) = volume_flow_initial_l(2) + &
-                                              v(k,ny,i) * dzu(k)
-                   volume_flow_area_l(2)    = volume_flow_area_l(2) + dzu(k)
-                ENDDO
-!
-!--             Correction if velocity at nzb+1 has been set zero further above
-                volume_flow_initial_l(2) = volume_flow_initial_l(2) + &
-                                           v_nzb_p1_for_vfc(i)
-             ENDDO
-          ENDIF
-
-#if defined( __parallel )
-          IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-          CALL MPI_ALLREDUCE( volume_flow_initial_l(1), volume_flow_initial(1),&
-                              2, MPI_REAL, MPI_SUM, comm2d, ierr )
-          IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-          CALL MPI_ALLREDUCE( volume_flow_area_l(1), volume_flow_area(1),      &
-                              2, MPI_REAL, MPI_SUM, comm2d, ierr )
-#else
-          volume_flow_initial = volume_flow_initial_l
-          volume_flow_area    = volume_flow_area_l
-#endif
-!
-!--       In case of 'bulk_velocity' mode, volume_flow_initial is overridden
-!--       and calculated from u|v_bulk instead.
-          IF ( TRIM( conserve_volume_flow_mode ) == 'bulk_velocity' )  THEN
-             volume_flow_initial(1) = u_bulk * volume_flow_area(1)
-             volume_flow_initial(2) = v_bulk * volume_flow_area(2)
-          ENDIF
-
-       ENDIF
 
 !
@@ -968,8 +895,8 @@
           sa_p  = sa
        ENDIF
-
+       
 
     ELSEIF ( TRIM( initializing_actions ) == 'read_restart_data'  .OR.    &
-             TRIM( initializing_actions ) == 'cyclic_fill' )  &
+         TRIM( initializing_actions ) == 'cyclic_fill' )  &
     THEN
 !
@@ -978,9 +905,5 @@
        IF ( TRIM( initializing_actions ) == 'cyclic_fill' )  THEN
 
-          WRITE (9,*) 'before read_parts_of_var_list'
-          CALL local_flush( 9 )
           CALL read_parts_of_var_list
-          WRITE (9,*) 'after read_parts_of_var_list'
-          CALL local_flush( 9 )
           CALL close_file( 13 )
 
@@ -1002,11 +925,11 @@
 !--          conditions are used)
              IF ( inflow_l )  THEN
-                DO  j = nys-1, nyn+1
+                DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      u(k,j,-1)  = mean_inflow_profiles(k,1)
-                      v(k,j,-1)  = mean_inflow_profiles(k,2)
-                      w(k,j,-1)  = 0.0
-                      pt(k,j,-1) = mean_inflow_profiles(k,4)
-                      e(k,j,-1)  = mean_inflow_profiles(k,5)
+                      u(k,j,nxlg:-1)  = mean_inflow_profiles(k,1)
+                      v(k,j,nxlg:-1)  = mean_inflow_profiles(k,2)
+                      w(k,j,nxlg:-1)  = 0.0
+                      pt(k,j,nxlg:-1) = mean_inflow_profiles(k,4)
+                      e(k,j,nxlg:-1)  = mean_inflow_profiles(k,5)
                    ENDDO
                 ENDDO
@@ -1064,9 +987,6 @@
 !
 !--    Read binary data from restart file
-          WRITE (9,*) 'before read_3d_binary'
-          CALL local_flush( 9 )
+
        CALL read_3d_binary
-          WRITE (9,*) 'after read_3d_binary'
-          CALL local_flush( 9 )
 
 !
@@ -1074,25 +994,4 @@
        IF ( TRIM( initializing_actions ) == 'cyclic_fill' .AND.  &
             topography /= 'flat' )  THEN
-!
-!--       Correction of initial volume flow
-          IF ( conserve_volume_flow )  THEN
-             IF ( nxr == nx )  THEN
-                DO  j = nys, nyn
-                   DO  k = nzb + 1, nzb_u_inner(j,nx)
-                      u_nzb_p1_for_vfc(j) = u_nzb_p1_for_vfc(j) + &
-                                            u(k,j,nx) * dzu(k)
-                   ENDDO
-                ENDDO
-             ENDIF
-             IF ( nyn == ny )  THEN
-                DO  i = nxl, nxr
-                   DO  k = nzb + 1, nzb_v_inner(ny,i)
-                      v_nzb_p1_for_vfc(i) = v_nzb_p1_for_vfc(i) + &
-                                            v(k,ny,i) * dzu(k)
-                   ENDDO
-                ENDDO
-             ENDIF
-          ENDIF
-
 !
 !--       Inside buildings set velocities and TKE back to zero.
@@ -1100,6 +999,6 @@
 !--       maybe revise later.
           IF ( timestep_scheme(1:5) == 'runge' )  THEN
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    u  (nzb:nzb_u_inner(j,i),j,i) = 0.0
                    v  (nzb:nzb_v_inner(j,i),j,i) = 0.0
@@ -1118,6 +1017,6 @@
              ENDDO
           ELSE
-             DO  i = nxl-1, nxr+1
-                DO  j = nys-1, nyn+1
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
                    u  (nzb:nzb_u_inner(j,i),j,i) = 0.0
                    v  (nzb:nzb_v_inner(j,i),j,i) = 0.0
@@ -1139,56 +1038,4 @@
 
 !
-!--    Calculate the initial volume flow at the right and north boundary
-       IF ( conserve_volume_flow  .AND.  &
-            TRIM( initializing_actions ) == 'cyclic_fill' )  THEN
-
-          volume_flow_initial_l = 0.0
-          volume_flow_area_l    = 0.0
-  
-          IF ( nxr == nx )  THEN
-             DO  j = nys, nyn
-                DO  k = nzb_2d(j,nx) + 1, nzt
-                   volume_flow_initial_l(1) = volume_flow_initial_l(1) + &
-                                              u(k,j,nx) * dzu(k)
-                   volume_flow_area_l(1)    = volume_flow_area_l(1) + dzu(k)
-                ENDDO
-!
-!--             Correction if velocity inside buildings has been set to zero
-!--             further above
-                volume_flow_initial_l(1) = volume_flow_initial_l(1) + &
-                                           u_nzb_p1_for_vfc(j)
-             ENDDO
-          ENDIF
-
-          IF ( nyn == ny )  THEN
-             DO  i = nxl, nxr
-                DO  k = nzb_2d(ny,i) + 1, nzt  
-                   volume_flow_initial_l(2) = volume_flow_initial_l(2) + &
-                                              v(k,ny,i) * dzu(k)
-                   volume_flow_area_l(2)    = volume_flow_area_l(2) + dzu(k)
-                ENDDO
-!
-!--             Correction if velocity inside buildings has been set to zero
-!--             further above
-                volume_flow_initial_l(2) = volume_flow_initial_l(2) + &
-                                           v_nzb_p1_for_vfc(i)
-             ENDDO
-          ENDIF
-
-#if defined( __parallel )
-          IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-          CALL MPI_ALLREDUCE( volume_flow_initial_l(1), volume_flow_initial(1),&
-                              2, MPI_REAL, MPI_SUM, comm2d, ierr )
-          IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-          CALL MPI_ALLREDUCE( volume_flow_area_l(1), volume_flow_area(1),      &
-                              2, MPI_REAL, MPI_SUM, comm2d, ierr )
-#else
-          volume_flow_initial = volume_flow_initial_l
-          volume_flow_area    = volume_flow_area_l
-#endif  
-       ENDIF
-
-
-!
 !--    Calculate initial temperature field and other constants used in case
 !--    of a sloping surface
